#define RCLK_0 digitalWrite(10, 0)
#define RCLK_1 digitalWrite(10, 1)

#define SDI_0 digitalWrite(11, 0)
#define SDI_1 digitalWrite(11, 1)

#define SCLK_0 digitalWrite(12, 0)
#define SCLK_1 digitalWrite(12, 1)

const char img[] = {
  0b00000001,
  0b00000001,
  0b11111111,
  0b00000001,
  0b00000001,
  0b00000000,
  0b11111111,
  0b00010001,
  0b00101001,
  0b01001001,
  0b10000110,
  0b00000000,
  0b11111111,
  0b10001001,
  0b10001001,
  0b10001001,
  0b10000001,
  0b00000000,
  0b11111111,
  0b10001001,
  0b10001001,
  0b10001001,
  0b10000001,
  0b00000000,
  0b11111111,
  0b10001001,
  0b10001001,
  0b10001001,
  0b10000001,
  0b00000000
};

void setup() {
  // put your setup code here, to run once:
  pinMode(12, 1);
  pinMode(11, 1);
  pinMode(10, 1);
}

void shift(unsigned char col, unsigned char row)
{
  int i = 0;
  
  for (i = 0; i < 8; i ++)
  {
    SCLK_0;
    if (col & 0x80)
      SDI_1;
    else
      SDI_0;
    SCLK_1;
    col <<= 1;
  }

  for (i = 0; i < 8; i ++)
  {
    SCLK_0;
    if (row & 0x80)
      SDI_1;
    else
      SDI_0;
    SCLK_1;
    row <<= 1;
  }
}

void loop() {
  
  static char img_index = 0;
  static unsigned long time  = millis();

  int i = 0;
  for (i = 0; i < 8; i++)
  {
    RCLK_0;
    shift(~(0x01<<i), img[(i + img_index)%30]);
    shift(0xff, 0);
    RCLK_1;
  }
  if (millis() - time > 100)
  {
    time = millis();
    img_index++;
  }
  if (img_index >= 30)
    img_index = 0;
}

